<!DOCTYPE html>
<html>
<head>
<meta charset="UTF-8">
<title>documentation/info_segments/abbrev_.info</title>
<meta name="Generator" content="Vim/9.1">
<meta name="plugin-version" content="vim9.0_v2">
<meta name="syntax" content="none">
<meta name="settings" content="number_lines,use_css,no_foldcolumn,expand_tabs,line_ids,pre_wrap,prevent_copy=,use_input_for_pc=none">
<meta name="colorscheme" content="PaperColor">
<style>
<!--
pre { white-space: pre-wrap; font-family: monospace; color: #d0d0d0; background-color: #000000; }
body { font-family: monospace; color: #d0d0d0; background-color: #000000; }
* { font-size: 1em; }
.textRainbow_lv1_p0 { color: #ffffe0; }
.textRainbow_lv0_o0 { color: #add8e6; }
.textRainbow_lv0_p0 { color: #add8e6; }
.LineNr { color: #585858; }
-->
</style>

<script>
<!--

/* function to open any folds containing a jumped-to line before jumping to it */
function JumpToLine()
{
  var lineNum;
  lineNum = window.location.hash;
  lineNum = lineNum.substr(1); /* strip off '#' */

  if (lineNum.indexOf('L') == -1) {
    lineNum = 'L'+lineNum;
  }
  var lineElem = document.getElementById(lineNum);
  /* Always jump to new location even if the line was hidden inside a fold, or
   * we corrected the raw number to a line ID.
   */
  if (lineElem) {
    lineElem.scrollIntoView(true);
  }
  return true;
}
if ('onhashchange' in window) {
  window.onhashchange = JumpToLine;
}

-->
</script>
</head>
<body onload='JumpToLine();'>
<pre id='vimCodeElement'>
<span id="L1" class="LineNr">  1 </span>10/16/87  abbrev_
<span id="L2" class="LineNr">  2 </span>
<span id="L3" class="LineNr">  3 </span>The abbrev_ subroutine provides a means of expanding abbreviations in
<span id="L4" class="LineNr">  4 </span>command lines and changing data in and extracting data from the profile
<span id="L5" class="LineNr">  5 </span>segments used by the abbrev command.  All of the features of the
<span id="L6" class="LineNr">  6 </span>command itself are available and a simple expand entry point is
<span id="L7" class="LineNr">  7 </span>provided for returning expanded command lines.
<span id="L8" class="LineNr">  8 </span>
<span id="L9" class="LineNr">  9 </span>
<span id="L10" class="LineNr"> 10 </span>Entry points in abbrev_:
<span id="L11" class="LineNr"> 11 </span>   <span class="textRainbow_lv0_p0">(</span>List is generated by the help command<span class="textRainbow_lv0_p0">)</span>
<span id="L12" class="LineNr"> 12 </span>
<span id="L13" class="LineNr"> 13 </span>
<span id="L14" class="LineNr"> 14 </span>:Entry: abbrev_: 02/07/84 abbrev_
<span id="L15" class="LineNr"> 15 </span>
<span id="L16" class="LineNr"> 16 </span>Function: The main entry point is used to expand and execute a command
<span id="L17" class="LineNr"> 17 </span>line.  The command line can be an abbrev request line, as recognized
<span id="L18" class="LineNr"> 18 </span>by the abbrev command.  An abbrev request line can be used to add and
<span id="L19" class="LineNr"> 19 </span>delete abbreviations and change the modes of operation of abbrev.  The
<span id="L20" class="LineNr"> 20 </span>abbrev command need not be invoked in the process before the abbrev_
<span id="L21" class="LineNr"> 21 </span>subroutine can be called.
<span id="L22" class="LineNr"> 22 </span>
<span id="L23" class="LineNr"> 23 </span>
<span id="L24" class="LineNr"> 24 </span>Syntax:
<span id="L25" class="LineNr"> 25 </span>declare abbrev_ entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L26" class="LineNr"> 26 </span>call abbrev_ <span class="textRainbow_lv0_p0">(</span>line_ptr<span class="textRainbow_lv0_o0">,</span> line_len<span class="textRainbow_lv0_o0">,</span> code<span class="textRainbow_lv0_p0">)</span>;
<span id="L27" class="LineNr"> 27 </span>
<span id="L28" class="LineNr"> 28 </span>
<span id="L29" class="LineNr"> 29 </span>Arguments:
<span id="L30" class="LineNr"> 30 </span>line_ptr
<span id="L31" class="LineNr"> 31 </span>   is a pointer to a character string to be interpreted as a command
<span id="L32" class="LineNr"> 32 </span>   line or an abbrev request line.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L33" class="LineNr"> 33 </span>line_len
<span id="L34" class="LineNr"> 34 </span>   is the number of characters in the input line.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L35" class="LineNr"> 35 </span>code
<span id="L36" class="LineNr"> 36 </span>   is a standard status code returned by the command processor.
<span id="L37" class="LineNr"> 37 </span>   <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L38" class="LineNr"> 38 </span>
<span id="L39" class="LineNr"> 39 </span>
<span id="L40" class="LineNr"> 40 </span>:Entry:  expand_line:  10/16/87 abbrev_$expand_line
<span id="L41" class="LineNr"> 41 </span>
<span id="L42" class="LineNr"> 42 </span>Function:  This entry point returns an expanded abbreviation of an
<span id="L43" class="LineNr"> 43 </span>input string that is of the type specified by the input parameter
<span id="L44" class="LineNr"> 44 </span>&quot;abbrev_type&quot;.  See the description of the abbrev command for a
<span id="L45" class="LineNr"> 45 </span>discussion of abbrev expansion.
<span id="L46" class="LineNr"> 46 </span>
<span id="L47" class="LineNr"> 47 </span>
<span id="L48" class="LineNr"> 48 </span>Syntax:
<span id="L49" class="LineNr"> 49 </span>declare abbrev_$expand_line entry <span class="textRainbow_lv0_p0">(</span>fixed bin<span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L50" class="LineNr"> 50 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L51" class="LineNr"> 51 </span>call abbrev_$expand_line <span class="textRainbow_lv0_p0">(</span>abbrev_type<span class="textRainbow_lv0_o0">,</span> in_ptr<span class="textRainbow_lv0_o0">,</span> in_len<span class="textRainbow_lv0_o0">,</span> space_ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L52" class="LineNr"> 52 </span>     space_len<span class="textRainbow_lv0_o0">,</span> out_ptr<span class="textRainbow_lv0_o0">,</span> out_len<span class="textRainbow_lv0_p0">)</span>;
<span id="L53" class="LineNr"> 53 </span>
<span id="L54" class="LineNr"> 54 </span>
<span id="L55" class="LineNr"> 55 </span>Arguments:
<span id="L56" class="LineNr"> 56 </span>abbrev_type
<span id="L57" class="LineNr"> 57 </span>   defines the types of abbreviations to expand.  Defined values are:
<span id="L58" class="LineNr"> 58 </span>   EXPAND_BOL_ONLY <span class="textRainbow_lv0_p0">(</span>1<span class="textRainbow_lv0_p0">)</span>, or EXPAND_INTERNAL_ONLY <span class="textRainbow_lv0_p0">(</span>2<span class="textRainbow_lv0_p0">)</span>, or
<span id="L59" class="LineNr"> 59 </span>   EXPAND_BOTH <span class="textRainbow_lv0_p0">(</span>3<span class="textRainbow_lv0_p0">)</span>.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L60" class="LineNr"> 60 </span>
<span id="L61" class="LineNr"> 61 </span>
<span id="L62" class="LineNr"> 62 </span>in_ptr
<span id="L63" class="LineNr"> 63 </span>   is a pointer to a character string to be expanded.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L64" class="LineNr"> 64 </span>in_len
<span id="L65" class="LineNr"> 65 </span>   is the number of characters in the input string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L66" class="LineNr"> 66 </span>space_ptr
<span id="L67" class="LineNr"> 67 </span>   is a pointer to a work space where the expanded character string can
<span id="L68" class="LineNr"> 68 </span>   be placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L69" class="LineNr"> 69 </span>space_len
<span id="L70" class="LineNr"> 70 </span>   is the number of characters available in the work space.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L71" class="LineNr"> 71 </span>out_ptr
<span id="L72" class="LineNr"> 72 </span>   points to the expanded string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L73" class="LineNr"> 73 </span>out_len
<span id="L74" class="LineNr"> 74 </span>   is the number of characters in the expanded string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L75" class="LineNr"> 75 </span>
<span id="L76" class="LineNr"> 76 </span>
<span id="L77" class="LineNr"> 77 </span>Notes:  If the length of the expanded string exceeds the length of the
<span id="L78" class="LineNr"> 78 </span>work space provided, the expanded line is allocated in the system free
<span id="L79" class="LineNr"> 79 </span>area <span class="textRainbow_lv0_p0">(</span>see the get_system_free_area_ subroutine<span class="textRainbow_lv0_p0">)</span>, It is the user's
<span id="L80" class="LineNr"> 80 </span>responsibility to free this storage when it is no longer needed.
<span id="L81" class="LineNr"> 81 </span>
<span id="L82" class="LineNr"> 82 </span>The space_ptr pointer should not point to the same string as in_ptr
<span id="L83" class="LineNr"> 83 </span>since expansion is done directly into the work space.
<span id="L84" class="LineNr"> 84 </span>
<span id="L85" class="LineNr"> 85 </span>
<span id="L86" class="LineNr"> 86 </span>:Entry:  expanded_line:  02/07/84 abbrev_$expanded_line
<span id="L87" class="LineNr"> 87 </span>
<span id="L88" class="LineNr"> 88 </span>
<span id="L89" class="LineNr"> 89 </span>Function:  This entry point returns an expanded version of an input
<span id="L90" class="LineNr"> 90 </span>string.  See the description of the abbrev command for a discussion of
<span id="L91" class="LineNr"> 91 </span>abbrev expansion.
<span id="L92" class="LineNr"> 92 </span>
<span id="L93" class="LineNr"> 93 </span>
<span id="L94" class="LineNr"> 94 </span>Syntax:
<span id="L95" class="LineNr"> 95 </span>declare abbrev_$expanded_line entry <span class="textRainbow_lv0_p0">(</span>ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span>
<span id="L96" class="LineNr"> 96 </span>     fixed bin<span class="textRainbow_lv1_p0">(</span>21<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_o0">,</span> ptr<span class="textRainbow_lv0_o0">,</span> fixed bin<span class="textRainbow_lv1_p0">(</span>35<span class="textRainbow_lv1_p0">)</span><span class="textRainbow_lv0_p0">)</span>;
<span id="L97" class="LineNr"> 97 </span>call abbrev_$expanded_line <span class="textRainbow_lv0_p0">(</span>in_ptr<span class="textRainbow_lv0_o0">,</span> in_len<span class="textRainbow_lv0_o0">,</span> space_ptr<span class="textRainbow_lv0_o0">,</span> space_len<span class="textRainbow_lv0_o0">,</span>
<span id="L98" class="LineNr"> 98 </span>     out_ptr<span class="textRainbow_lv0_o0">,</span> out_len<span class="textRainbow_lv0_p0">)</span>;
<span id="L99" class="LineNr"> 99 </span>
<span id="L100" class="LineNr">100 </span>
<span id="L101" class="LineNr">101 </span>Arguments:
<span id="L102" class="LineNr">102 </span>in_ptr
<span id="L103" class="LineNr">103 </span>   is a pointer to a character string to be expanded.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L104" class="LineNr">104 </span>in_len
<span id="L105" class="LineNr">105 </span>   is the number of characters in the input string.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L106" class="LineNr">106 </span>space_ptr
<span id="L107" class="LineNr">107 </span>   is a pointer to a work space where the expanded character string can
<span id="L108" class="LineNr">108 </span>   be placed.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L109" class="LineNr">109 </span>space_len
<span id="L110" class="LineNr">110 </span>   is the number of characters available in the work space.  <span class="textRainbow_lv0_p0">(</span>Input<span class="textRainbow_lv0_p0">)</span>
<span id="L111" class="LineNr">111 </span>out_ptr
<span id="L112" class="LineNr">112 </span>   points to the expanded string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L113" class="LineNr">113 </span>out_len
<span id="L114" class="LineNr">114 </span>   is the number of characters in the expanded string.  <span class="textRainbow_lv0_p0">(</span>Output<span class="textRainbow_lv0_p0">)</span>
<span id="L115" class="LineNr">115 </span>
<span id="L116" class="LineNr">116 </span>
<span id="L117" class="LineNr">117 </span>Notes:  If the length of the expanded string exceeds the length of the
<span id="L118" class="LineNr">118 </span>work space provided, the expanded line is allocated in the system free
<span id="L119" class="LineNr">119 </span>area <span class="textRainbow_lv0_p0">(</span>see the get_system_free_area_ subroutine<span class="textRainbow_lv0_p0">)</span>, It is the user's
<span id="L120" class="LineNr">120 </span>responsibility to free this storage when it is no longer needed.
<span id="L121" class="LineNr">121 </span>
<span id="L122" class="LineNr">122 </span>The space_ptr pointer should not point to the same string as in_ptr
<span id="L123" class="LineNr">123 </span>since expansion is done directly into the work space.
<span id="L124" class="LineNr">124 </span>
<span id="L125" class="LineNr">125 </span>
<span id="L126" class="LineNr">126 </span>:Entry:  set_cp:  02/07/84 abbrev_$set_cp
<span id="L127" class="LineNr">127 </span>
<span id="L128" class="LineNr">128 </span>
<span id="L129" class="LineNr">129 </span>Function:  This entry point sets up a different command processor to be
<span id="L130" class="LineNr">130 </span>called by the abbrev_ subroutine after a command line is expanded.  Its
<span id="L131" class="LineNr">131 </span>argument is an entry.  If the first pointer in the entry is null, the
<span id="L132" class="LineNr">132 </span>command processor to be called is command_processor_.
<span id="L133" class="LineNr">133 </span>
<span id="L134" class="LineNr">134 </span>
<span id="L135" class="LineNr">135 </span>Syntax:
<span id="L136" class="LineNr">136 </span>declare abbrev_$set_cp entry <span class="textRainbow_lv0_p0">(</span>entry<span class="textRainbow_lv0_p0">)</span>;
<span id="L137" class="LineNr">137 </span>call abbrev_$set_cp <span class="textRainbow_lv0_p0">(</span>cp_entry<span class="textRainbow_lv0_p0">)</span>;
<span id="L138" class="LineNr">138 </span>
<span id="L139" class="LineNr">139 </span>
<span id="L140" class="LineNr">140 </span>Arguments:
<span id="L141" class="LineNr">141 </span>cp_entry
<span id="L142" class="LineNr">142 </span>   is a command processor entry point.
</pre>
<script defer src='https://static.cloudflareinsights.com/beacon.min.js' data-cf-beacon='{"token": "4b6a131644014aa29fd88953508c3a3d"}'></script></body>
</html>
<!-- vim: set foldmethod=manual : -->
